diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/global-route-manager-impl.cc ns-3.47/src/internet/model/global-route-manager-impl.cc
--- ns-3.46/src/internet/model/global-route-manager-impl.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/global-route-manager-impl.cc	2026-02-16 16:08:49.611230000 -0800
@@ -14,16 +14,22 @@
 
 #include "candidate-queue.h"
 #include "global-router-interface.h"
-#include "ipv4-global-routing.h"
+#include "global-routing.h"
+#include "ipv4-l3-protocol.h"
 #include "ipv4.h"
+#include "ipv6-l3-protocol.h"
+#include "ipv6-route.h"
 
 #include "ns3/assert.h"
+#include "ns3/boolean.h"
+#include "ns3/config.h"
 #include "ns3/fatal-error.h"
 #include "ns3/log.h"
 #include "ns3/node-list.h"
 #include "ns3/simulator.h"
 
 #include <algorithm>
+#include <iomanip>
 #include <iostream>
 #include <queue>
 #include <utility>
@@ -38,33 +44,27 @@
  * @brief Stream insertion operator.
  *
  * @param os the reference to the output stream
- * @param exit the exit node
+ * @param exit the exit gateway and egress interface index
  * @returns the reference to the output stream
  */
 std::ostream&
-operator<<(std::ostream& os, const SPFVertex::NodeExit_t& exit)
+operator<<(std::ostream& os, const std::pair<Ipv4Address, int>& exit)
 {
-    os << "(" << exit.first << " ," << exit.second << ")";
+    os << "(" << exit.first << ", " << exit.second << ")";
     return os;
 }
 
+/**
+ * @brief Stream insertion operator.
+ *
+ * @param os the reference to the output stream
+ * @param exit the exit gateway and egress interface index
+ * @returns the reference to the output stream
+ */
 std::ostream&
-operator<<(std::ostream& os, const SPFVertex::ListOfSPFVertex_t& vs)
+operator<<(std::ostream& os, const std::pair<Ipv6Address, int>& exit)
 {
-    os << "{";
-    for (auto iter = vs.begin(); iter != vs.end();)
-    {
-        os << (*iter)->m_vertexId;
-        if (++iter != vs.end())
-        {
-            os << ", ";
-        }
-        else
-        {
-            break;
-        }
-    }
-    os << "}";
+    os << "(" << exit.first << ", " << exit.second << ")";
     return os;
 }
 
@@ -73,14 +73,14 @@
 // SPFVertex Implementation
 //
 // ---------------------------------------------------------------------------
-
-SPFVertex::SPFVertex()
+template <typename T>
+SPFVertex<T>::SPFVertex()
     : m_vertexType(VertexUnknown),
       m_vertexId("255.255.255.255"),
       m_lsa(nullptr),
       m_distanceFromRoot(SPF_INFINITY),
       m_rootOif(SPF_INFINITY),
-      m_nextHop("0.0.0.0"),
+      m_nextHop(IpAddress::GetZero()),
       m_parents(),
       m_children(),
       m_vertexProcessed(false)
@@ -88,32 +88,34 @@
     NS_LOG_FUNCTION(this);
 }
 
-SPFVertex::SPFVertex(GlobalRoutingLSA* lsa)
+template <typename T>
+SPFVertex<T>::SPFVertex(GlobalRoutingLSA<IpManager>* lsa)
     : m_vertexId(lsa->GetLinkStateId()),
       m_lsa(lsa),
       m_distanceFromRoot(SPF_INFINITY),
       m_rootOif(SPF_INFINITY),
-      m_nextHop("0.0.0.0"),
+      m_nextHop(IpAddress::GetZero()),
       m_parents(),
       m_children(),
       m_vertexProcessed(false)
 {
     NS_LOG_FUNCTION(this << lsa);
 
-    if (lsa->GetLSType() == GlobalRoutingLSA::RouterLSA)
+    if (lsa->GetLSType() == GlobalRoutingLSA<IpManager>::RouterLSA)
     {
         NS_LOG_LOGIC("Setting m_vertexType to VertexRouter");
-        m_vertexType = SPFVertex::VertexRouter;
+        m_vertexType = SPFVertex<T>::VertexRouter;
         m_node = lsa->GetNode();
     }
-    else if (lsa->GetLSType() == GlobalRoutingLSA::NetworkLSA)
+    else if (lsa->GetLSType() == GlobalRoutingLSA<IpManager>::NetworkLSA)
     {
         NS_LOG_LOGIC("Setting m_vertexType to VertexNetwork");
-        m_vertexType = SPFVertex::VertexNetwork;
+        m_vertexType = SPFVertex<T>::VertexNetwork;
     }
 }
 
-SPFVertex::~SPFVertex()
+template <typename T>
+SPFVertex<T>::~SPFVertex()
 {
     NS_LOG_FUNCTION(this);
 
@@ -145,7 +147,7 @@
         //
         // Note that m_children.pop_front () is not necessary as this
         // p is removed from the children list when p is deleted
-        SPFVertex* p = m_children.front();
+        SPFVertex<T>* p = m_children.front();
         // 'p' == 0, this child is already deleted by its other parent
         if (p == nullptr)
         {
@@ -165,64 +167,73 @@
     NS_LOG_LOGIC("Vertex-" << m_vertexId << " completed deleted");
 }
 
+template <typename T>
 void
-SPFVertex::SetVertexType(SPFVertex::VertexType type)
+SPFVertex<T>::SetVertexType(SPFVertex<T>::VertexType type)
 {
     NS_LOG_FUNCTION(this << type);
     m_vertexType = type;
 }
 
-SPFVertex::VertexType
-SPFVertex::GetVertexType() const
+template <typename T>
+SPFVertex<T>::VertexType
+SPFVertex<T>::GetVertexType() const
 {
     NS_LOG_FUNCTION(this);
     return m_vertexType;
 }
 
+template <typename T>
 void
-SPFVertex::SetVertexId(Ipv4Address id)
+SPFVertex<T>::SetVertexId(IpAddress id)
 {
     NS_LOG_FUNCTION(this << id);
     m_vertexId = id;
 }
 
-Ipv4Address
-SPFVertex::GetVertexId() const
+template <typename T>
+SPFVertex<T>::IpAddress
+SPFVertex<T>::GetVertexId() const
 {
     NS_LOG_FUNCTION(this);
     return m_vertexId;
 }
 
+template <typename T>
 void
-SPFVertex::SetLSA(GlobalRoutingLSA* lsa)
+SPFVertex<T>::SetLSA(GlobalRoutingLSA<IpManager>* lsa)
 {
     NS_LOG_FUNCTION(this << lsa);
     m_lsa = lsa;
 }
 
-GlobalRoutingLSA*
-SPFVertex::GetLSA() const
+template <typename T>
+GlobalRoutingLSA<T>*
+SPFVertex<T>::GetLSA() const
 {
     NS_LOG_FUNCTION(this);
     return m_lsa;
 }
 
+template <typename T>
 void
-SPFVertex::SetDistanceFromRoot(uint32_t distance)
+SPFVertex<T>::SetDistanceFromRoot(uint32_t distance)
 {
     NS_LOG_FUNCTION(this << distance);
     m_distanceFromRoot = distance;
 }
 
+template <typename T>
 uint32_t
-SPFVertex::GetDistanceFromRoot() const
+SPFVertex<T>::GetDistanceFromRoot() const
 {
     NS_LOG_FUNCTION(this);
     return m_distanceFromRoot;
 }
 
+template <typename T>
 void
-SPFVertex::SetParent(SPFVertex* parent)
+SPFVertex<T>::SetParent(SPFVertex* parent)
 {
     NS_LOG_FUNCTION(this << parent);
 
@@ -231,8 +242,9 @@
     m_parents.push_back(parent);
 }
 
-SPFVertex*
-SPFVertex::GetParent(uint32_t i) const
+template <typename T>
+SPFVertex<T>*
+SPFVertex<T>::GetParent(uint32_t i) const
 {
     NS_LOG_FUNCTION(this << i);
 
@@ -250,8 +262,9 @@
     return *iter;
 }
 
+template <typename T>
 void
-SPFVertex::MergeParent(const SPFVertex* v)
+SPFVertex<T>::MergeParent(const SPFVertex* v)
 {
     NS_LOG_FUNCTION(this << v);
 
@@ -264,8 +277,9 @@
     NS_LOG_LOGIC("After merge, list of parents = " << m_parents);
 }
 
+template <typename T>
 void
-SPFVertex::SetRootExitDirection(Ipv4Address nextHop, int32_t id)
+SPFVertex<T>::SetRootExitDirection(IpAddress nextHop, int32_t id)
 {
     NS_LOG_FUNCTION(this << nextHop << id);
 
@@ -278,15 +292,17 @@
     m_rootOif = id;
 }
 
+template <typename T>
 void
-SPFVertex::SetRootExitDirection(SPFVertex::NodeExit_t exit)
+SPFVertex<T>::SetRootExitDirection(SPFVertex<T>::NodeExit_t exit)
 {
     NS_LOG_FUNCTION(this << exit);
     SetRootExitDirection(exit.first, exit.second);
 }
 
-SPFVertex::NodeExit_t
-SPFVertex::GetRootExitDirection(uint32_t i) const
+template <typename T>
+SPFVertex<T>::NodeExit_t
+SPFVertex<T>::GetRootExitDirection(uint32_t i) const
 {
     NS_LOG_FUNCTION(this << i);
 
@@ -301,8 +317,9 @@
     return *iter;
 }
 
-SPFVertex::NodeExit_t
-SPFVertex::GetRootExitDirection() const
+template <typename T>
+SPFVertex<T>::NodeExit_t
+SPFVertex<T>::GetRootExitDirection() const
 {
     NS_LOG_FUNCTION(this);
 
@@ -311,8 +328,9 @@
     return GetRootExitDirection(0);
 }
 
+template <typename T>
 void
-SPFVertex::MergeRootExitDirections(const SPFVertex* vertex)
+SPFVertex<T>::MergeRootExitDirections(const SPFVertex* vertex)
 {
     NS_LOG_FUNCTION(this << vertex);
 
@@ -325,8 +343,9 @@
     m_ecmpRootExits.unique();
 }
 
+template <typename T>
 void
-SPFVertex::InheritAllRootExitDirections(const SPFVertex* vertex)
+SPFVertex<T>::InheritAllRootExitDirections(const SPFVertex* vertex)
 {
     NS_LOG_FUNCTION(this << vertex);
 
@@ -342,22 +361,25 @@
                            vertex->m_ecmpRootExits.end());
 }
 
+template <typename T>
 uint32_t
-SPFVertex::GetNRootExitDirections() const
+SPFVertex<T>::GetNRootExitDirections() const
 {
     NS_LOG_FUNCTION(this);
     return m_ecmpRootExits.size();
 }
 
+template <typename T>
 uint32_t
-SPFVertex::GetNChildren() const
+SPFVertex<T>::GetNChildren() const
 {
     NS_LOG_FUNCTION(this);
     return m_children.size();
 }
 
-SPFVertex*
-SPFVertex::GetChild(uint32_t n) const
+template <typename T>
+SPFVertex<T>*
+SPFVertex<T>::GetChild(uint32_t n) const
 {
     NS_LOG_FUNCTION(this << n);
     uint32_t j = 0;
@@ -373,30 +395,34 @@
     return nullptr;
 }
 
+template <typename T>
 uint32_t
-SPFVertex::AddChild(SPFVertex* child)
+SPFVertex<T>::AddChild(SPFVertex* child)
 {
     NS_LOG_FUNCTION(this << child);
     m_children.push_back(child);
     return m_children.size();
 }
 
+template <typename T>
 void
-SPFVertex::SetVertexProcessed(bool value)
+SPFVertex<T>::SetVertexProcessed(bool value)
 {
     NS_LOG_FUNCTION(this << value);
     m_vertexProcessed = value;
 }
 
+template <typename T>
 bool
-SPFVertex::IsVertexProcessed() const
+SPFVertex<T>::IsVertexProcessed() const
 {
     NS_LOG_FUNCTION(this);
     return m_vertexProcessed;
 }
 
+template <typename T>
 void
-SPFVertex::ClearVertexProcessed()
+SPFVertex<T>::ClearVertexProcessed()
 {
     NS_LOG_FUNCTION(this);
     for (uint32_t i = 0; i < this->GetNChildren(); i++)
@@ -406,8 +432,9 @@
     this->SetVertexProcessed(false);
 }
 
+template <typename T>
 Ptr<Node>
-SPFVertex::GetNode() const
+SPFVertex<T>::GetNode() const
 {
     return m_node;
 }
@@ -417,49 +444,52 @@
 // GlobalRouteManagerLSDB Implementation
 //
 // ---------------------------------------------------------------------------
-
-GlobalRouteManagerLSDB::GlobalRouteManagerLSDB()
+template <typename T>
+GlobalRouteManagerLSDB<T>::GlobalRouteManagerLSDB()
     : m_database(),
       m_extdatabase()
 {
     NS_LOG_FUNCTION(this);
 }
 
-GlobalRouteManagerLSDB::~GlobalRouteManagerLSDB()
+template <typename T>
+GlobalRouteManagerLSDB<T>::~GlobalRouteManagerLSDB()
 {
     NS_LOG_FUNCTION(this);
     for (auto i = m_database.begin(); i != m_database.end(); i++)
     {
         NS_LOG_LOGIC("free LSA");
-        GlobalRoutingLSA* temp = i->second;
+        GlobalRoutingLSA<IpManager>* temp = i->second;
         delete temp;
     }
     for (uint32_t j = 0; j < m_extdatabase.size(); j++)
     {
         NS_LOG_LOGIC("free ASexternalLSA");
-        GlobalRoutingLSA* temp = m_extdatabase.at(j);
+        GlobalRoutingLSA<IpManager>* temp = m_extdatabase.at(j);
         delete temp;
     }
     NS_LOG_LOGIC("clear map");
     m_database.clear();
 }
 
+template <typename T>
 void
-GlobalRouteManagerLSDB::Initialize()
+GlobalRouteManagerLSDB<T>::Initialize()
 {
     NS_LOG_FUNCTION(this);
     for (auto i = m_database.begin(); i != m_database.end(); i++)
     {
-        GlobalRoutingLSA* temp = i->second;
-        temp->SetStatus(GlobalRoutingLSA::LSA_SPF_NOT_EXPLORED);
+        GlobalRoutingLSA<IpManager>* temp = i->second;
+        temp->SetStatus(GlobalRoutingLSA<IpManager>::LSA_SPF_NOT_EXPLORED);
     }
 }
 
+template <typename T>
 void
-GlobalRouteManagerLSDB::Insert(Ipv4Address addr, GlobalRoutingLSA* lsa)
+GlobalRouteManagerLSDB<T>::Insert(IpAddress addr, GlobalRoutingLSA<IpManager>* lsa)
 {
     NS_LOG_FUNCTION(this << addr << lsa);
-    if (lsa->GetLSType() == GlobalRoutingLSA::ASExternalLSAs)
+    if (lsa->GetLSType() == GlobalRoutingLSA<IpManager>::ASExternalLSAs)
     {
         m_extdatabase.push_back(lsa);
     }
@@ -469,22 +499,25 @@
     }
 }
 
-GlobalRoutingLSA*
-GlobalRouteManagerLSDB::GetExtLSA(uint32_t index) const
+template <typename T>
+GlobalRoutingLSA<typename GlobalRouteManagerLSDB<T>::IpManager>*
+GlobalRouteManagerLSDB<T>::GetExtLSA(uint32_t index) const
 {
     NS_LOG_FUNCTION(this << index);
     return m_extdatabase.at(index);
 }
 
+template <typename T>
 uint32_t
-GlobalRouteManagerLSDB::GetNumExtLSAs() const
+GlobalRouteManagerLSDB<T>::GetNumExtLSAs() const
 {
     NS_LOG_FUNCTION(this);
     return m_extdatabase.size();
 }
 
-GlobalRoutingLSA*
-GlobalRouteManagerLSDB::GetLSA(Ipv4Address addr) const
+template <typename T>
+GlobalRoutingLSA<typename GlobalRouteManagerLSDB<T>::IpManager>*
+GlobalRouteManagerLSDB<T>::GetLSA(IpAddress addr) const
 {
     NS_LOG_FUNCTION(this << addr);
     //
@@ -500,8 +533,9 @@
     return nullptr;
 }
 
-GlobalRoutingLSA*
-GlobalRouteManagerLSDB::GetLSAByLinkData(Ipv4Address addr) const
+template <typename T>
+GlobalRoutingLSA<typename GlobalRouteManagerLSDB<T>::IpManager>*
+GlobalRouteManagerLSDB<T>::GetLSAByLinkData(IpAddress addr) const
 {
     NS_LOG_FUNCTION(this << addr);
     //
@@ -509,12 +543,12 @@
     //
     for (auto i = m_database.begin(); i != m_database.end(); i++)
     {
-        GlobalRoutingLSA* temp = i->second;
+        GlobalRoutingLSA<IpManager>* temp = i->second;
         // Iterate among temp's Link Records
         for (uint32_t j = 0; j < temp->GetNLinkRecords(); j++)
         {
-            GlobalRoutingLinkRecord* lr = temp->GetLinkRecord(j);
-            if (lr->GetLinkType() == GlobalRoutingLinkRecord::TransitNetwork &&
+            GlobalRoutingLinkRecord<IpManager>* lr = temp->GetLinkRecord(j);
+            if (lr->GetLinkType() == GlobalRoutingLinkRecord<IpManager>::TransitNetwork &&
                 lr->GetLinkData() == addr)
             {
                 return temp;
@@ -530,14 +564,16 @@
 //
 // ---------------------------------------------------------------------------
 
-GlobalRouteManagerImpl::GlobalRouteManagerImpl()
+template <typename T>
+GlobalRouteManagerImpl<T>::GlobalRouteManagerImpl()
     : m_spfroot(nullptr)
 {
     NS_LOG_FUNCTION(this);
-    m_lsdb = new GlobalRouteManagerLSDB();
+    m_lsdb = new GlobalRouteManagerLSDB<IpManager>();
 }
 
-GlobalRouteManagerImpl::~GlobalRouteManagerImpl()
+template <typename T>
+GlobalRouteManagerImpl<T>::~GlobalRouteManagerImpl()
 {
     NS_LOG_FUNCTION(this);
     if (m_lsdb)
@@ -546,8 +582,9 @@
     }
 }
 
+template <typename T>
 void
-GlobalRouteManagerImpl::DebugUseLsdb(GlobalRouteManagerLSDB* lsdb)
+GlobalRouteManagerImpl<T>::DebugUseLsdb(GlobalRouteManagerLSDB<T>* lsdb)
 {
     NS_LOG_FUNCTION(this << lsdb);
     if (m_lsdb)
@@ -557,19 +594,20 @@
     m_lsdb = lsdb;
 }
 
+template <typename T>
 void
-GlobalRouteManagerImpl::DeleteGlobalRoutes()
+GlobalRouteManagerImpl<T>::DeleteGlobalRoutes()
 {
     NS_LOG_FUNCTION(this);
     for (auto i = NodeList::Begin(); i != NodeList::End(); i++)
     {
         Ptr<Node> node = *i;
-        Ptr<GlobalRouter> router = node->GetObject<GlobalRouter>();
+        Ptr<GlobalRouter<IpManager>> router = node->GetObject<GlobalRouter<IpManager>>();
         if (!router)
         {
             continue;
         }
-        Ptr<Ipv4GlobalRouting> gr = router->GetRoutingProtocol();
+        Ptr<GlobalRouting<IpRoutingProtocol>> gr = router->GetRoutingProtocol();
         uint32_t j = 0;
         uint32_t nRoutes = gr->GetNRoutes();
         NS_LOG_LOGIC("Deleting " << gr->GetNRoutes() << " routes from node " << node->GetId());
@@ -587,7 +625,7 @@
     {
         NS_LOG_LOGIC("Deleting LSDB, creating new one");
         delete m_lsdb;
-        m_lsdb = new GlobalRouteManagerLSDB();
+        m_lsdb = new GlobalRouteManagerLSDB<IpManager>();
     }
 }
 
@@ -600,8 +638,10 @@
 // add them to the Link State DataBase (LSDB) from which the routes will
 // ultimately be computed.
 //
+
+template <typename T>
 void
-GlobalRouteManagerImpl::BuildGlobalRoutingDatabase()
+GlobalRouteManagerImpl<T>::BuildGlobalRoutingDatabase()
 {
     NS_LOG_FUNCTION(this);
     //
@@ -612,7 +652,7 @@
     {
         Ptr<Node> node = *i;
 
-        Ptr<GlobalRouter> rtr = node->GetObject<GlobalRouter>();
+        Ptr<GlobalRouter<IpManager>> rtr = node->GetObject<GlobalRouter<IpManager>>();
         //
         // Ignore nodes that aren't participating in routing.
         //
@@ -628,13 +668,13 @@
         // DiscoverLSAs () will get zero as the number since no routes have been
         // found.
         //
-        Ptr<Ipv4GlobalRouting> grouting = rtr->GetRoutingProtocol();
+        Ptr<GlobalRouting<IpRoutingProtocol>> grouting = rtr->GetRoutingProtocol();
         uint32_t numLSAs = rtr->DiscoverLSAs();
         NS_LOG_LOGIC("Found " << numLSAs << " LSAs");
 
         for (uint32_t j = 0; j < numLSAs; ++j)
         {
-            auto lsa = new GlobalRoutingLSA();
+            auto lsa = new GlobalRoutingLSA<IpManager>();
             //
             // This is the call to actually fetch a Link State Advertisement from the
             // router.
@@ -682,8 +722,10 @@
 // algorithm then iterates again.  It terminates when the candidate
 // list becomes empty.
 //
+
+template <typename T>
 void
-GlobalRouteManagerImpl::InitializeRoutes()
+GlobalRouteManagerImpl<T>::InitializeRoutes()
 {
     NS_LOG_FUNCTION(this);
     //
@@ -697,7 +739,7 @@
         // Look for the GlobalRouter interface that indicates that the node is
         // participating in routing.
         //
-        Ptr<GlobalRouter> rtr = node->GetObject<GlobalRouter>();
+        Ptr<GlobalRouter<IpManager>> rtr = node->GetObject<GlobalRouter<IpManager>>();
 
         uint32_t systemId = Simulator::GetSystemId();
         // Ignore nodes that are not assigned to our systemId (distributed sim)
@@ -731,25 +773,27 @@
 // vertices not already on the list.  If a lower-cost path is found to a
 // vertex already on the candidate list, store the new (lower) cost.
 //
+
+template <typename T>
 void
-GlobalRouteManagerImpl::SPFNext(SPFVertex* v, CandidateQueue& candidate)
+GlobalRouteManagerImpl<T>::SPFNext(SPFVertex<T>* v, CandidateQueue<T>& candidate)
 {
     NS_LOG_FUNCTION(this << v << &candidate);
 
-    SPFVertex* w = nullptr;
-    GlobalRoutingLSA* w_lsa = nullptr;
-    GlobalRoutingLinkRecord* l = nullptr;
+    SPFVertex<T>* w = nullptr;
+    GlobalRoutingLSA<IpManager>* w_lsa = nullptr;
+    GlobalRoutingLinkRecord<IpManager>* l = nullptr;
     uint32_t distance = 0;
     uint32_t numRecordsInVertex = 0;
     //
     // V points to a Router-LSA or Network-LSA
     // Loop over the links in router LSA or attached routers in Network LSA
     //
-    if (v->GetVertexType() == SPFVertex::VertexRouter)
+    if (v->GetVertexType() == SPFVertex<T>::VertexRouter)
     {
         numRecordsInVertex = v->GetLSA()->GetNLinkRecords();
     }
-    if (v->GetVertexType() == SPFVertex::VertexNetwork)
+    if (v->GetVertexType() == SPFVertex<T>::VertexNetwork)
     {
         numRecordsInVertex = v->GetLSA()->GetNAttachedRouters();
     }
@@ -758,7 +802,7 @@
     for (uint32_t i = 0; i < numRecordsInVertex; i++)
     {
         // Get w_lsa:  In case of V is Router-LSA
-        if (v->GetVertexType() == SPFVertex::VertexRouter)
+        if (v->GetVertexType() == SPFVertex<T>::VertexRouter)
         {
             NS_LOG_LOGIC("Examining link " << i << " of " << v->GetVertexId() << "'s "
                                            << v->GetLSA()->GetNLinkRecords() << " link records");
@@ -769,7 +813,7 @@
             //
             l = v->GetLSA()->GetLinkRecord(i);
             NS_ASSERT(l != nullptr);
-            if (l->GetLinkType() == GlobalRoutingLinkRecord::StubNetwork)
+            if (l->GetLinkType() == GlobalRoutingLinkRecord<IpManager>::StubNetwork)
             {
                 NS_LOG_LOGIC("Found a Stub record to " << l->GetLinkId());
                 continue;
@@ -779,7 +823,7 @@
             // the vertex W's LSA (router-LSA or network-LSA) in Area A's link state
             // database.
             //
-            if (l->GetLinkType() == GlobalRoutingLinkRecord::PointToPoint)
+            if (l->GetLinkType() == GlobalRoutingLinkRecord<IpManager>::PointToPoint)
             {
                 //
                 // Lookup the link state advertisement of the new link -- we call it <w> in
@@ -790,7 +834,7 @@
                 NS_LOG_LOGIC("Found a P2P record from " << v->GetVertexId() << " to "
                                                         << w_lsa->GetLinkStateId());
             }
-            else if (l->GetLinkType() == GlobalRoutingLinkRecord::TransitNetwork)
+            else if (l->GetLinkType() == GlobalRoutingLinkRecord<IpManager>::TransitNetwork)
             {
                 w_lsa = m_lsdb->GetLSA(l->GetLinkId());
                 NS_ASSERT(w_lsa);
@@ -803,7 +847,7 @@
             }
         }
         // Get w_lsa:  In case of V is Network-LSA
-        if (v->GetVertexType() == SPFVertex::VertexNetwork)
+        if (v->GetVertexType() == SPFVertex<T>::VertexNetwork)
         {
             w_lsa = m_lsdb->GetLSAByLinkData(v->GetLSA()->GetAttachedRouter(i));
             if (!w_lsa)
@@ -822,7 +866,7 @@
         // If the link is to a router that is already in the shortest path first tree
         // then we have it covered -- ignore it.
         //
-        if (w_lsa->GetStatus() == GlobalRoutingLSA::LSA_SPF_IN_SPFTREE)
+        if (w_lsa->GetStatus() == GlobalRoutingLSA<IpManager>::LSA_SPF_IN_SPFTREE)
         {
             NS_LOG_LOGIC("Skipping ->  LSA " << w_lsa->GetLinkStateId() << " already in SPF tree");
             continue;
@@ -833,7 +877,7 @@
         // calculated) shortest path to vertex V and the advertised cost of the link
         // between vertices V and W.
         //
-        if (v->GetLSA()->GetLSType() == GlobalRoutingLSA::RouterLSA)
+        if (v->GetLSA()->GetLSType() == GlobalRoutingLSA<IpManager>::RouterLSA)
         {
             NS_ASSERT(l != nullptr);
             distance = v->GetDistanceFromRoot() + l->GetMetric();
@@ -846,7 +890,7 @@
         NS_LOG_LOGIC("Considering w_lsa " << w_lsa->GetLinkStateId());
 
         // Is there already vertex w in candidate list?
-        if (w_lsa->GetStatus() == GlobalRoutingLSA::LSA_SPF_NOT_EXPLORED)
+        if (w_lsa->GetStatus() == GlobalRoutingLSA<IpManager>::LSA_SPF_NOT_EXPLORED)
         {
             // Calculate nexthop to w
             // We need to figure out how to actually get to the new router represented
@@ -855,10 +899,10 @@
             // used to forward the packets.
 
             // prepare vertex w
-            w = new SPFVertex(w_lsa);
+            w = new SPFVertex<T>(w_lsa);
             if (SPFNexthopCalculation(v, w, l, distance))
             {
-                w_lsa->SetStatus(GlobalRoutingLSA::LSA_SPF_CANDIDATE);
+                w_lsa->SetStatus(GlobalRoutingLSA<IpManager>::LSA_SPF_CANDIDATE);
                 //
                 // Push this new vertex onto the priority queue (ordered by distance from the
                 // root node).
@@ -873,7 +917,7 @@
                 NS_ASSERT_MSG(0, "SPFNexthopCalculation never return false, but it does now!");
             }
         }
-        else if (w_lsa->GetStatus() == GlobalRoutingLSA::LSA_SPF_CANDIDATE)
+        else if (w_lsa->GetStatus() == GlobalRoutingLSA<IpManager>::LSA_SPF_CANDIDATE)
         {
             //
             // We have already considered the link represented by <w>.  What wse have to
@@ -888,7 +932,7 @@
              * with the cost we just determined (w->distance) to see
              * if we've found a shorter path.
              */
-            SPFVertex* cw;
+            SPFVertex<T>* cw;
             cw = candidate.Find(w_lsa->GetLinkStateId());
             if (cw->GetDistanceFromRoot() < distance)
             {
@@ -919,7 +963,7 @@
                 // is very different from quagga (blame ns3::GlobalRouteManagerImpl)
 
                 // prepare vertex w
-                w = new SPFVertex(w_lsa);
+                w = new SPFVertex<T>(w_lsa);
                 SPFNexthopCalculation(v, w, l, distance);
                 cw->MergeRootExitDirections(w);
                 cw->MergeParent(w);
@@ -962,11 +1006,13 @@
 //
 // For now, this is greatly simplified from the quagga code
 //
+
+template <typename T>
 int
-GlobalRouteManagerImpl::SPFNexthopCalculation(SPFVertex* v,
-                                              SPFVertex* w,
-                                              GlobalRoutingLinkRecord* l,
-                                              uint32_t distance)
+GlobalRouteManagerImpl<T>::SPFNexthopCalculation(SPFVertex<T>* v,
+                                                 SPFVertex<T>* w,
+                                                 GlobalRoutingLinkRecord<IpManager>* l,
+                                                 uint32_t distance)
 {
     NS_LOG_FUNCTION(this << v << w << l << distance);
     //
@@ -1011,7 +1057,7 @@
         // node if this root node is a router.  We then need to see if this node <w>
         // is a router.
         //
-        if (w->GetVertexType() == SPFVertex::VertexRouter)
+        if (w->GetVertexType() == SPFVertex<T>::VertexRouter)
         {
             //
             // In the case of point-to-point links, the link data field (m_linkData) of a
@@ -1027,7 +1073,7 @@
             // SPFGetLink.
             //
             NS_ASSERT(l);
-            GlobalRoutingLinkRecord* linkRemote = nullptr;
+            GlobalRoutingLinkRecord<IpManager>* linkRemote = nullptr;
             linkRemote = SPFGetNextLink(w, v, linkRemote);
             //
             // At this point, <l> is the Global Router Link Record describing the point-
@@ -1040,13 +1086,29 @@
             // from the root node to the host represented by vertex <w>, you have to send
             // the packet to the next hop address specified in w->m_nextHop.
             //
-            Ipv4Address nextHop = linkRemote->GetLinkData();
+            IpAddress nextHop;
+            if constexpr (IsIpv4)
+            {
+                nextHop = linkRemote->GetLinkData();
+            }
+            else
+            {
+                nextHop = linkRemote->GetLinkLocData();
+            }
             //
             // Now find the outgoing interface corresponding to the point to point link
             // from the perspective of <v> -- remember that <l> is the link "from"
             // <v> "to" <w>.
             //
-            uint32_t outIf = FindOutgoingInterfaceId(l->GetLinkData());
+            uint32_t outIf;
+            if constexpr (IsIpv4)
+            {
+                outIf = FindOutgoingInterfaceId(l->GetLinkData());
+            }
+            else
+            {
+                outIf = FindOutgoingInterfaceId(l->GetLinkLocData());
+            }
 
             w->SetRootExitDirection(nextHop, outIf);
             w->SetDistanceFromRoot(distance);
@@ -1058,15 +1120,15 @@
         }
         else
         {
-            NS_ASSERT(w->GetVertexType() == SPFVertex::VertexNetwork);
+            NS_ASSERT(w->GetVertexType() == SPFVertex<T>::VertexNetwork);
             // W is a directly connected network; no next hop is required
-            GlobalRoutingLSA* w_lsa = w->GetLSA();
-            NS_ASSERT(w_lsa->GetLSType() == GlobalRoutingLSA::NetworkLSA);
+            GlobalRoutingLSA<IpManager>* w_lsa = w->GetLSA();
+            NS_ASSERT(w_lsa->GetLSType() == GlobalRoutingLSA<IpManager>::NetworkLSA);
             // Find outgoing interface ID for this network
             uint32_t outIf =
                 FindOutgoingInterfaceId(w_lsa->GetLinkStateId(), w_lsa->GetNetworkLSANetworkMask());
             // Set the next hop to 0.0.0.0 meaning "not exist"
-            Ipv4Address nextHop = Ipv4Address::GetZero();
+            IpAddress nextHop = IpAddress::GetZero();
             w->SetRootExitDirection(nextHop, outIf);
             w->SetDistanceFromRoot(distance);
             w->SetParent(v);
@@ -1076,7 +1138,7 @@
             return 1;
         }
     }
-    else if (v->GetVertexType() == SPFVertex::VertexNetwork)
+    else if (v->GetVertexType() == SPFVertex<T>::VertexNetwork)
     {
         // See if any of v's parents are the root
         if (v->GetParent() == m_spfroot)
@@ -1085,8 +1147,8 @@
             // directly connects the calculating router to the destination
             // router.  The list of next hops is then determined by
             // examining the destination's router-LSA...
-            NS_ASSERT(w->GetVertexType() == SPFVertex::VertexRouter);
-            GlobalRoutingLinkRecord* linkRemote = nullptr;
+            NS_ASSERT(w->GetVertexType() == SPFVertex<T>::VertexRouter);
+            GlobalRoutingLinkRecord<IpManager>* linkRemote = nullptr;
             while ((linkRemote = SPFGetNextLink(w, v, linkRemote)))
             {
                 /* ...For each link in the router-LSA that points back to the
@@ -1095,7 +1157,15 @@
                  * use can then be derived from the next hop IP address (or
                  * it can be inherited from the parent network).
                  */
-                Ipv4Address nextHop = linkRemote->GetLinkData();
+                IpAddress nextHop;
+                if constexpr (IsIpv4)
+                {
+                    nextHop = linkRemote->GetLinkData();
+                }
+                else
+                {
+                    nextHop = linkRemote->GetLinkLocData();
+                }
                 uint32_t outIf = v->GetRootExitDirection().second;
                 w->SetRootExitDirection(nextHop, outIf);
                 NS_LOG_LOGIC("Next hop from " << v->GetVertexId() << " to " << w->GetVertexId()
@@ -1146,16 +1216,19 @@
 // to <w>.  If prev_link is not NULL, we return a Global Router Link Record
 // representing a possible *second* link from <v> to <w>.
 //
-GlobalRoutingLinkRecord*
-GlobalRouteManagerImpl::SPFGetNextLink(SPFVertex* v,
-                                       SPFVertex* w,
-                                       GlobalRoutingLinkRecord* prev_link)
+
+template <typename T>
+
+GlobalRoutingLinkRecord<typename GlobalRouteManagerImpl<T>::IpManager>*
+GlobalRouteManagerImpl<T>::SPFGetNextLink(SPFVertex<T>* v,
+                                          SPFVertex<T>* w,
+                                          GlobalRoutingLinkRecord<IpManager>* prev_link)
 {
     NS_LOG_FUNCTION(this << v << w << prev_link);
 
     bool skip = true;
     bool found_prev_link = false;
-    GlobalRoutingLinkRecord* l;
+    GlobalRoutingLinkRecord<IpManager>* l;
     //
     // If prev_link is 0, we are really looking for the first link, not the next
     // link.
@@ -1223,8 +1296,10 @@
 //
 // Used for unit tests.
 //
+
+template <typename T>
 void
-GlobalRouteManagerImpl::DebugSPFCalculate(Ipv4Address root)
+GlobalRouteManagerImpl<T>::DebugSPFCalculate(IpAddress root)
 {
     NS_LOG_FUNCTION(this << root);
     SPFCalculate(root);
@@ -1236,19 +1311,21 @@
 // can safely be added to the next-hop router and SPF does not need
 // to be run
 //
+
+template <typename T>
 bool
-GlobalRouteManagerImpl::CheckForStubNode(Ipv4Address root)
+GlobalRouteManagerImpl<T>::CheckForStubNode(IpAddress root)
 {
     NS_LOG_FUNCTION(this << root);
-    GlobalRoutingLSA* rlsa = m_lsdb->GetLSA(root);
-    Ipv4Address myRouterId = rlsa->GetLinkStateId();
+    GlobalRoutingLSA<IpManager>* rlsa = m_lsdb->GetLSA(root);
+    IpAddress myRouterId = rlsa->GetLinkStateId();
     int transits = 0;
-    GlobalRoutingLinkRecord* transitLink = nullptr;
+    GlobalRoutingLinkRecord<IpManager>* transitLink = nullptr;
     for (uint32_t i = 0; i < rlsa->GetNLinkRecords(); i++)
     {
-        GlobalRoutingLinkRecord* l = rlsa->GetLinkRecord(i);
-        if (l->GetLinkType() == GlobalRoutingLinkRecord::TransitNetwork ||
-            l->GetLinkType() == GlobalRoutingLinkRecord::PointToPoint)
+        GlobalRoutingLinkRecord<IpManager>* l = rlsa->GetLinkRecord(i);
+        if (l->GetLinkType() == GlobalRoutingLinkRecord<IpManager>::TransitNetwork ||
+            l->GetLinkType() == GlobalRoutingLinkRecord<IpManager>::PointToPoint)
         {
             transits++;
             transitLink = l;
